SystemOrganization addCategory: #'MH-calculator-tests'!

TestCase subclass: #MyStackMachineTest
	instanceVariableNames: 'machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MH-calculator-tests'!

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/4/2020 22:02'!
testAdd 
	machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		add.
	self assert: machine stack size equals: 1.
	self assert: machine stack first equals: 7! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/4/2020 21:08'!
testDiv
	machine := MyStackMachine new.
	machine 
		push: 3;
		push: 4;
		div.
	self assert: machine stack size equals: 1.
	self assert: machine stack first equals: 4 / 3! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/4/2020 22:24'!
testDup
	machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		dup.
	self assert: machine stack size equals: 3;
	assert: machine stack first equals: 3;
	assert: machine stack second equals: 4;
	assert: machine stack third equals: 4.
	
	! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/4/2020 22:00'!
testExchg
	machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		exchg.
	self assert: machine stack size equals: 2.
	self assert: machine stack first equals: 4.
	self assert: machine stack last equals: 3.! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/5/2020 18:16'!
testMin
	machine := MyStackMachine new.
	machine
		push: 5;
		push: 3;
		min.
	self assert: machine stack size equals: 1.
	self assert: machine stack first equals: -2! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/6/2020 15:14'!
testMul
machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		mul.
	self assert: machine stack size equals: 1.
	self assert: machine stack first equals: 12! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/6/2020 17:03'!
testNeg
machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		neg.
	self assert: machine stack size equals: 2.
	self assert: machine stack last equals: -4.
	! !

!MyStackMachineTest methodsFor: 'tests' stamp: 'milhar 1/4/2020 22:06'!
testRotUp
	machine := MyStackMachine new.
	machine
		push: 3;
		push: 4;
		push: 1;
		rotUp.
	self
		assert: machine stack size equals: 3;
		assert: machine stack first equals: 1;
		assert: machine stack second equals: 4;
		assert: machine stack last equals: 3! !
